
#include <stdio.h>

extern void dis_8086(FILE *, unsigned int, const unsigned char *,
		     const unsigned char *, int);

main(int argc, char *argv[])
{
  unsigned char buf[65536];
  int nread, start;
  unsigned int nbytes;
  int def_size;

  if (argc > 1 && argv[1][0] == '+')
    {
      def_size = 1;
      argc--;
      argv++;
    }
  else
    {
      def_size = 0;
    }

  start = (argc > 1) ? strtoul(argv[1], (char **)0, 16) : 0;

  if (argc > 2)
    {
      nbytes = strtoul(argv[2], (char **)0, 16) + start;
      if (nbytes > sizeof buf)
	nbytes = sizeof buf;
    }
  else
    {
      nbytes = sizeof buf;
    }

  if (argc > 3 && freopen(argv[3], "r", stdin) == 0)
    {
      fprintf(stderr, "dis86: unable to open \"%s\"\n", argv[3]);
      return 2;
    }

  nread = fread(buf, 1, nbytes, stdin);
  if (nread == 0)
    {
      fputs("dis86: unable to read input\n", stderr);
      return 2;
    }

  dis_8086(stdout, start, buf + start, buf + nread, def_size);
  return 0;
}
